%
%   RNE-UKF
%
% tuning
for b = 1:1
    %%  Transmitter
% 	Generate random data.
	Tx = randi([0, mod-1], (n_S+m-1), 1);   % Random symbols
    
% 	Modulate data.
    s = qammod(Tx, mod)./sqrt(mod);
    
    %%  Propagation distortion
% 	Generate time-variant coefficients.
%     a = time_variant(length(c), 1, fade);
    
% 	Compute linear filter response.
%     h = filter(a' + c', 1, s);
    h = filter(chan, s);
    
% 	Nonlinear distortion.
%     g = h + distortion*(h).^2;
    
% 	Front end noise, as AWGN.
%     v = complex(random('Normal', 0, k_n),random('Normal', 0, k_n));
    
% 	Channel response.
    r_k = h;%(g + v);

for k = 1:n_S
%%  Equalize
%     Update channel response vector.
    r = r_k([k:k+m-1],1);
    
% 	Update feedback state vector.
    x_fb_re = x_re;
    x_fb_im = x_im;
    
% 	Augment RNE input vector.
    z_re = [1; real(r); real(u); x_fb_re];
    z_im = [1; imag(r); imag(u); x_fb_im];
    
% 	Update decision-feedback input vector.
    i=0;
    for i = 1:n-1;
        u(n - i + 1) = u(n - i);
    end
    if m > k
    	u(1) = yc;
    else
        if training == 1
            u(1) = s(k-d);
        else
            u(1) = s_hat;
        end
    end
    
% 	Augment RNE weight matrix
%     Wh = [w(1:9)';w(10:18)';w(19:27)';w(28:36)';w(37:45)';w(46:54)'];
    
% 	Recurrent Neural Net propagation.
    [y(1), x_re] = neural(z_re, w(1:(L/2)));
    [y(2), x_im] = neural(z_im, w((L/2)+1:L));
        
% 	Convert output to complex.
    yc = complex(y(1), y(2));
    
% 	Make symbol decision.
    s_hat(1) = qammod(qamdemod(yc*sqrt(mod),mod), mod);
    
%%  UKF
    if training == 1
%         Calculate sigma points.
        X = sigma_points(P, w, lambda, forget);

%         Propagate sigma points.
        D = zeros(2,2*L+1);
        for i = 1:(length(X))                     
            D(:,i) = [neural(z_re, X(1:(L/2),i)); neural(z_im, X((L/2)+1:L,i))];
        end
        
%         Calculate weighted mean of the posterior sigma points.
        y = D*WM;                                

%         Calculate weighted (co)variance of the posterior sigma points
        Y=0;
        for i = 1:length(D)
            Y = Y + WC(i)*((D(:,i) - y)*(D(:,i) - y)'); %s ettellernannetsted
        end

%         Add artificial measurement-noise (co)variance for good measure
        Y = Y + R;

%         Calculate posterior cross-covariance.
        C=0;
        for i = 1:length(D)
            C = C + WC(i)*((X(:,i) - w)*(D(:,i) - y)');
        end
        
%         Calculate Kalman gain
        K = C*inv(Y);
        
%         Calculate error
        e = [[real(u(1));imag(u(1))] - y];
        
%         Update the weights
        w = w + K*e;
        
%         Update the covariance
        P = P - K*Y*K';
        
%         Ensure positive definiteness.
        P = validateCovMatrix(P);
    end
%%  Receiver

%%  Log data.

%     BER(k,1) = qamdemod(yc,mod);
%     BER(k,2) = Tx;
%     BER(k,3) = qamdemod(r_k, mod);
%     debug_eig(:,k) = real(eig(P));
    log_e(k) = abs(e(1))+abs(e(2));
    log_y(k) = yc;
    log_s_hat(k) = u(1);
end

% [SER_y(b,1),SER_y(b,2)] = symerr(log_s_hat,s(m:end));
% [SER_r(b,1),SER_r(b,2)] = symerr(r_k(m:end),s(m:end));
filtered_MSE(:,b) = log_e;
% unfiltered_MSE(:,b) = abs(r_k(1:n_S) - s(1:n_S));
semilogy(filtered_MSE(:,b));hold on;%semilogy(filtered_MSE(:,b));
% P = diag(10*ones(1,length(w)));
% w = -0.5 + rand(L,1);
% newre = sum(filtered_MSE(1,:))/n_S;
% newim = sum(filtered_MSE(2,:))/n_S;
% if (newre < oldre) || (newim < oldim)
%     if newre < (oldre)
%         w_desp(1:31,desp) = w(1:31);
%         oldre = newre;
%     else
%         w_desp(1:31,desp) = w_desp(1:31,desp - 1);
%     end
%     if newim < (oldim)
%         w_desp(32:62,desp) = w(32:62);
%         oldim = newim;
%     else
%         w_desp(32:62,desp) = w_desp(32:62,desp - 1);
%     end
%     desp = desp + 1;
%     Normal_Error(:,desp-824) = [newre; newim; (desp-1)];
end
% end
%% For Ploting and Debugging:
grid on
% RNE_improvement = (SER_r(:,2) - SER_y(:,2))*100;
% plot(RNE_improvement)
% semilogy(filtered_MSE(:,b));hold on;semilogy(filtered_MSE(:,b));grid on
% semilogy(log_e);grid on;
% hold off; scatter(real(r_k), imag(r_k), 10, 'g', 'filled');
% grid on; hold on; 
% scatter(real(log_y), imag(log_y), 10, 'b', 'filled');
% scatter(real(ref), imag(ref), 100, '+', 'r', 'LineWidth', 1.5)
% 
% hold off; semilogy(Normal_Error(1,:)); hold on; grid on; semilogy(Normal_Error(2,:))
% 
% hold off;semilogy(filtered_MSE(1,:));hold on;semilogy(filtered_MSE(2,:));grid on;
% plot(filtered_MSE(1,:));hold on;plot(filtered_MSE(2,:));grid on;hold off;
% Plot filter response and true signal:
% h= plot([BER(1:N,2) BER(1:N,1)]);grid on;
% legend('Filter response', 'Referense signal');
% 
% Scatterplot:
% scatterplot(log_y(:));hold on;
% 
% Plot MSE of filter output:
% semilogy(filtered_MSE);grid on;
% 
% Plot MSE of channel response and filter output:
% semilogy([unfiltered_MSE(1:n_S), filtered_MSE(1:n_S)]);grid on;
% 
% Display total filter MSE improvement:
% MSE_improvement = sum(unfiltered_MSE - filtered_MSE)
% 
% Display total filter MSE:
% total_MSE = sum(filtered_MSE,2)
% Normal_MSE = sum(filtered_MSE,2)/n_S
% 
% Display bit error rate:
% [Symbol_Errors, Bit_Error_Rate] = symerr(BER(1:n_S,1),BER(1:n_S,2))
% 
% Display RNE bit error rate improvement:
% SER_improvement_Percent = 100*(symerr(BER(1:n_S,1),BER(1:n_S,2)) - symerr(BER(1:N,3),BER(1:n_S,2)))/n_S
% 
